#ifndef __ASSOCIATED_POA__
#define __ASSOCIATED_POA__

#ifndef __CORBA_H_EXTERNAL_GUARD__
#include <omniORB3/CORBA.h>
#endif

template <class T>
class AssociatedPOA 
{
	protected :

		AssociatedPOA();  

      PortableServer::POA_ptr GetPOA() const;

	private :

      PortableServer::POA_ptr CreatePOA();

		static PortableServer::POA_ptr s_poa;
};

template <class T>
PortableServer::POA_ptr AssociatedPOA<T>::s_poa = 0;

template <class T>
AssociatedPOA<T>::AssociatedPOA<T>()
{
   if (0 == s_poa)
   {
      s_poa = CreatePOA();
   }
}  

template<class T>
PortableServer::POA_ptr AssociatedPOA<T>::GetPOA() const
{
   return s_poa;
}

template<class T>
PortableServer::POA_ptr AssociatedPOA<T>::CreatePOA()
{
	if (0 == s_poa)
	{
		int argc = 0;

      CORBA::ORB_var orb = CORBA::ORB_init(argc ,0,"");

		CORBA::Object_var obj = orb->resolve_initial_references("RootPOA");
		s_poa = PortableServer::POA::_narrow(obj);
   }

	return s_poa;
}

#endif // __ASSOCIATED_POA__
