#include "NamedCounterDataIteratorImpl.h"

#include <iostream>
using std::cout;
using std::endl;

#pragma warning(disable : 4786)  // identifier was truncated to '255' characters in the debug information

NamedCounterDataIteratorImpl::NamedCounterDataIteratorImpl(
   NamedCounterFactoryImpl::CounterContainer &counters)
	:	EvictorBase("NamedCounterIteratorImpl"),
      m_counters(counters),
      m_current(counters.beginList())
{ 
	cout << "NamedCounterDataIteratorImpl::NamedCounterDataIteratorImpl() - " << this <<   endl; 
}

NamedCounterDataIteratorImpl::~NamedCounterDataIteratorImpl()
{
	cout << "NamedCounterDataIteratorImpl::~NamedCounterDataIteratorImpl() - " << this <<   endl; 
}

CORBA::Boolean NamedCounterDataIteratorImpl::next_n(
   CORBA::ULong how_many, 
	counterDataSeq_out theCounters)
{
	cout << "NamedCounterDataIteratorImpl::next_n() - " << how_many << endl; 

   CORBA::ULong numCounters = 0;

   theCounters = new counterDataSeq(how_many);

   theCounters->length(how_many);

   while (m_current != m_counters.endList() && 
          numCounters < how_many)
   {
      struct CounterData data;

      data.name = (*m_current)->name();
      data.value = (*m_current)->value();

      theCounters[numCounters] = data;
	   ++m_current;
      ++numCounters;
   }

   theCounters->length(numCounters);

   return (numCounters != 0);
}

void NamedCounterDataIteratorImpl::destroy()
{
   EvictorBase::destroy();
}

bool NamedCounterDataIteratorImpl::AtEnd()
{
   return (m_current == m_counters.endList());
}

